> ## Documentation Index
> Fetch the complete documentation index at: https://docs.threetone.in/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Conversation Details

> Get the details of a particular conversation



## OpenAPI

````yaml https://api.threetone.in/openapi.json get /v1/voiceai/conversations/{conversation_id}
openapi: 3.1.0
info:
  title: Threetone API Documentation
  version: 1.0.0
servers:
  - url: https://api.threetone.in
    description: Production
security: []
paths:
  /v1/voiceai/conversations/{conversation_id}:
    get:
      tags:
        - Conversations
      summary: Get Conversation Details
      description: Get the details of a particular conversation
      operationId: conversations_get
      parameters:
        - name: conversation_id
          in: path
          required: true
          schema:
            type: string
            description: The id of the conversation you're taking the action on.
            title: Conversation Id
          description: The id of the conversation you're taking the action on.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetConversationResponseModel'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
        - HTTPBearer: []
components:
  schemas:
    GetConversationResponseModel:
      properties:
        agent_id:
          type: string
          title: Agent Id
          description: The ID of the agent
        agent_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Agent Name
          description: The name of the agent
        conversation_id:
          type: string
          title: Conversation Id
          description: The unique identifier for the conversation
        status:
          $ref: '#/components/schemas/ConversationStatus'
          description: Current status of the conversation
        user_id:
          anyOf:
            - type: string
            - type: 'null'
          title: User Id
          description: ID of the end user (for agent owner's identification)
        branch_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Branch Id
          description: Agent branch for this conversation, if applicable
        transcript:
          items:
            $ref: '#/components/schemas/ConversationHistoryTranscriptCommonModel'
          type: array
          title: Transcript
          description: List of transcript entries
        metadata:
          $ref: '#/components/schemas/ConversationHistoryMetadataCommonModel'
          description: Conversation metadata
        analysis:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryAnalysisCommonModel'
            - type: 'null'
          description: Conversation analysis results
        conversation_initiation_client_data:
          anyOf:
            - $ref: '#/components/schemas/ConversationInitiationClientDataRequest'
            - type: 'null'
          description: Client data from conversation initiation
        has_audio:
          type: boolean
          title: Has Audio
          description: Whether audio recording is available
        has_user_audio:
          type: boolean
          title: Has User Audio
          description: Whether user audio is available
        has_response_audio:
          type: boolean
          title: Has Response Audio
          description: Whether agent response audio is available
        batch_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Batch Id
          description: Batch call ID if this conversation was part of a batch call
        batch_recipient_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Batch Recipient Id
          description: >-
            Batch call recipient ID if this conversation was part of a batch
            call
      type: object
      required:
        - agent_id
        - conversation_id
        - status
        - transcript
        - metadata
        - has_audio
        - has_user_audio
        - has_response_audio
      title: GetConversationResponseModel
      description: Response model for Get Conversation Details endpoint.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ConversationStatus:
      type: string
      enum:
        - initiated
        - in-progress
        - processing
        - done
        - failed
      title: ConversationStatus
      description: Status of a conversation (GetConversationResponseModelStatus)
    ConversationHistoryTranscriptCommonModel:
      properties:
        role:
          $ref: '#/components/schemas/TranscriptRole'
          description: Role of the speaker (user/agent)
        message:
          anyOf:
            - type: string
            - type: 'null'
          title: Message
          description: The message content
        time_in_call_secs:
          type: integer
          title: Time In Call Secs
          description: Time in call when this message occurred
        interrupted:
          type: boolean
          title: Interrupted
          description: Whether the message was interrupted
          default: false
        original_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Original Message
          description: Original message before any modifications
        source_medium:
          anyOf:
            - $ref: '#/components/schemas/SourceMedium'
            - type: 'null'
          description: Source medium (audio/text)
        llm_override:
          anyOf:
            - type: string
            - type: 'null'
          title: Llm Override
          description: LLM override used for this turn
        tool_calls:
          items:
            $ref: >-
              #/components/schemas/ConversationHistoryTranscriptToolCallCommonModel
          type: array
          title: Tool Calls
        tool_results:
          items:
            anyOf:
              - $ref: >-
                  #/components/schemas/ConversationHistoryTranscriptOtherToolsResultCommonModel
              - $ref: >-
                  #/components/schemas/ConversationHistoryTranscriptSystemToolResultCommonModel
              - $ref: >-
                  #/components/schemas/ConversationHistoryTranscriptApiIntegrationWebhookToolsResultCommonModel
              - $ref: >-
                  #/components/schemas/ConversationHistoryTranscriptWorkflowToolsResultCommonModel
          type: array
          title: Tool Results
        feedback:
          anyOf:
            - $ref: '#/components/schemas/UserFeedback'
            - type: 'null'
        conversation_turn_metrics:
          anyOf:
            - $ref: '#/components/schemas/ConversationTurnMetrics'
            - type: 'null'
        rag_retrieval_info:
          anyOf:
            - $ref: '#/components/schemas/RagRetrievalInfo'
            - type: 'null'
        llm_usage:
          anyOf:
            - $ref: '#/components/schemas/LLMUsage'
            - type: 'null'
        agent_metadata:
          anyOf:
            - $ref: '#/components/schemas/AgentMetadata'
            - type: 'null'
      type: object
      required:
        - role
        - time_in_call_secs
      title: ConversationHistoryTranscriptCommonModel
      description: Transcript entry for a conversation turn.
    ConversationHistoryMetadataCommonModel:
      properties:
        start_time_unix_secs:
          type: integer
          title: Start Time Unix Secs
          description: Unix timestamp when conversation started
        call_duration_secs:
          type: integer
          title: Call Duration Secs
          description: Duration of the call in seconds
        accepted_time_unix_secs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Accepted Time Unix Secs
          description: Unix timestamp when conversation was accepted
        cost:
          anyOf:
            - type: integer
            - type: 'null'
          title: Cost
          description: Total cost in credits
        charging:
          anyOf:
            - $ref: '#/components/schemas/ConversationChargingCommonModel'
            - type: 'null'
        deletion_settings:
          anyOf:
            - $ref: '#/components/schemas/ConversationDeletionSettings'
            - type: 'null'
        feedback:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryFeedbackCommonModel'
            - type: 'null'
        authorization_method:
          $ref: '#/components/schemas/AuthorizationMethod'
          default: public
        phone_call:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryPhoneCallModel'
            - type: 'null'
          description: Phone call metadata
        batch_call:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryBatchCallModel'
            - type: 'null'
        termination_reason:
          type: string
          title: Termination Reason
          description: Reason the conversation ended
          default: ''
        error:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryErrorCommonModel'
            - type: 'null'
        warnings:
          items:
            type: string
          type: array
          title: Warnings
        main_language:
          anyOf:
            - type: string
            - type: 'null'
          title: Main Language
          description: Detected main language of conversation
        rag_usage:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryRagUsageCommonModel'
            - type: 'null'
        text_only:
          type: boolean
          title: Text Only
          description: Whether conversation is text-only
          default: false
        features_usage:
          anyOf:
            - $ref: '#/components/schemas/FeaturesUsageCommonModel'
            - type: 'null'
        ree_assistant:
          anyOf:
            - $ref: '#/components/schemas/ConversationHistoryReeAssistantCommonModel'
            - type: 'null'
        initiator_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Initiator Id
          description: ID of the initiator
        conversation_initiation_source:
          $ref: >-
            #/components/schemas/app__domains__conversations__schemas__ConversationInitiationSource
          default: unknown
        conversation_initiation_source_version:
          anyOf:
            - type: string
              maxLength: 50
            - type: 'null'
          title: Conversation Initiation Source Version
        timezone:
          anyOf:
            - type: string
            - type: 'null'
          title: Timezone
          description: Timezone for the conversation
        initiation_trigger:
          anyOf:
            - oneOf:
                - $ref: '#/components/schemas/DefaultConversationInitiationTrigger'
                - $ref: '#/components/schemas/ZendeskConversationInitiationTrigger'
              discriminator:
                propertyName: trigger_type
                mapping:
                  default:
                    $ref: '#/components/schemas/DefaultConversationInitiationTrigger'
                  zendesk:
                    $ref: '#/components/schemas/ZendeskConversationInitiationTrigger'
            - type: 'null'
          title: Initiation Trigger
        async_metadata:
          anyOf:
            - $ref: '#/components/schemas/AsyncConversationMetadata'
            - type: 'null'
        whatsapp:
          anyOf:
            - $ref: '#/components/schemas/WhatsAppConversationInfo'
            - type: 'null'
        agent_created_from:
          $ref: '#/components/schemas/AgentDefinitionSource'
          default: unknown
        agent_last_updated_from:
          $ref: '#/components/schemas/AgentDefinitionSource'
          default: unknown
      type: object
      required:
        - start_time_unix_secs
        - call_duration_secs
      title: ConversationHistoryMetadataCommonModel
      description: Metadata for a conversation.
    ConversationHistoryAnalysisCommonModel:
      properties:
        call_successful:
          $ref: '#/components/schemas/EvaluationSuccessResult'
          description: Whether the call was successful
        transcript_summary:
          type: string
          title: Transcript Summary
          description: AI-generated summary of the transcript (short paragraph)
        evaluation_criteria_results:
          additionalProperties:
            $ref: >-
              #/components/schemas/ConversationHistoryEvaluationCriteriaResultCommonModel
          type: object
          title: Evaluation Criteria Results
          description: Results of evaluation criteria (keyed by criteria_id)
        evaluation_criteria_results_list:
          items:
            $ref: >-
              #/components/schemas/ConversationHistoryEvaluationCriteriaResultCommonModel
          type: array
          title: Evaluation Criteria Results List
          description: Results of evaluation criteria (as list)
        data_collection_results:
          additionalProperties:
            $ref: '#/components/schemas/DataCollectionResultCommonModel'
          type: object
          title: Data Collection Results
          description: Results of data collection (keyed by data_collection_id)
        data_collection_results_list:
          items:
            $ref: '#/components/schemas/DataCollectionResultCommonModel'
          type: array
          title: Data Collection Results List
          description: Results of data collection (as list)
      type: object
      required:
        - call_successful
        - transcript_summary
      title: ConversationHistoryAnalysisCommonModel
      description: Analysis results for a conversation.
    ConversationInitiationClientDataRequest:
      properties:
        conversation_config_override:
          anyOf:
            - $ref: '#/components/schemas/ConversationConfigClientOverride-Output'
            - type: 'null'
        custom_llm_extra_body:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Custom Llm Extra Body
        user_id:
          anyOf:
            - type: string
            - type: 'null'
          title: User Id
          description: ID of the end user (for agent owner's identification)
        source_info:
          anyOf:
            - $ref: >-
                #/components/schemas/app__domains__conversations__schemas__ConversationInitiationSourceInfo
            - type: 'null'
        dynamic_variables:
          anyOf:
            - additionalProperties:
                anyOf:
                  - type: string
                  - type: integer
                  - type: number
                  - type: boolean
                  - type: 'null'
              type: object
            - type: 'null'
          title: Dynamic Variables
      type: object
      title: ConversationInitiationClientDataRequest
      description: Client data sent when initiating a conversation.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    TranscriptRole:
      type: string
      enum:
        - user
        - agent
      title: TranscriptRole
      description: Role of the speaker in a transcript entry
    SourceMedium:
      type: string
      enum:
        - audio
        - text
      title: SourceMedium
      description: Source medium for transcript messages
    ConversationHistoryTranscriptToolCallCommonModel:
      properties:
        type:
          anyOf:
            - $ref: '#/components/schemas/ToolType'
            - type: 'null'
        request_id:
          type: string
          title: Request Id
          description: Unique request ID for this tool call
        tool_name:
          type: string
          title: Tool Name
          description: Name of the tool
        params_as_json:
          type: string
          title: Params As Json
          description: Tool parameters as JSON string
        tool_has_been_called:
          type: boolean
          title: Tool Has Been Called
          description: Whether the tool was actually invoked
        tool_details:
          anyOf:
            - $ref: >-
                #/components/schemas/ConversationHistoryTranscriptToolCallWebhookDetails
            - $ref: >-
                #/components/schemas/ConversationHistoryTranscriptToolCallClientDetails
            - $ref: >-
                #/components/schemas/ConversationHistoryTranscriptToolCallMCPDetails
            - $ref: >-
                #/components/schemas/ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails
            - type: 'null'
          title: Tool Details
      type: object
      required:
        - request_id
        - tool_name
        - params_as_json
        - tool_has_been_called
      title: ConversationHistoryTranscriptToolCallCommonModel
      description: A tool call made during the conversation.
    ConversationHistoryTranscriptOtherToolsResultCommonModel:
      properties:
        request_id:
          type: string
          title: Request Id
        tool_name:
          type: string
          title: Tool Name
        result_value:
          type: string
          title: Result Value
        is_error:
          type: boolean
          title: Is Error
        tool_has_been_called:
          type: boolean
          title: Tool Has Been Called
        tool_latency_secs:
          type: number
          title: Tool Latency Secs
          default: 0
        dynamic_variable_updates:
          items:
            $ref: '#/components/schemas/DynamicVariableUpdateCommonModel'
          type: array
          title: Dynamic Variable Updates
        type:
          anyOf:
            - $ref: '#/components/schemas/OtherToolType'
            - type: 'null'
      type: object
      required:
        - request_id
        - tool_name
        - result_value
        - is_error
        - tool_has_been_called
      title: ConversationHistoryTranscriptOtherToolsResultCommonModel
      description: Result from client/webhook/mcp tool execution.
    ConversationHistoryTranscriptSystemToolResultCommonModel:
      properties:
        request_id:
          type: string
          title: Request Id
        tool_name:
          type: string
          title: Tool Name
        result_value:
          type: string
          title: Result Value
        is_error:
          type: boolean
          title: Is Error
        tool_has_been_called:
          type: boolean
          title: Tool Has Been Called
        tool_latency_secs:
          type: number
          title: Tool Latency Secs
          default: 0
        dynamic_variable_updates:
          items:
            $ref: '#/components/schemas/DynamicVariableUpdateCommonModel'
          type: array
          title: Dynamic Variable Updates
        type:
          type: string
          const: system
          title: Type
          default: system
        result:
          anyOf:
            - $ref: '#/components/schemas/EndCallToolResultModel'
            - $ref: '#/components/schemas/LanguageDetectionToolResultModel'
            - $ref: '#/components/schemas/TransferToAgentToolResultSuccessModel'
            - $ref: '#/components/schemas/TransferToAgentToolResultErrorModel'
            - $ref: '#/components/schemas/TransferToNumberResultTwilioSuccessModel'
            - $ref: '#/components/schemas/TransferToNumberResultSipSuccessModel'
            - $ref: '#/components/schemas/TransferToNumberResultErrorModel'
            - $ref: '#/components/schemas/SkipTurnToolResponseModel'
            - $ref: '#/components/schemas/PlayDTMFResultSuccessModel'
            - $ref: '#/components/schemas/PlayDTMFResultErrorModel'
            - $ref: '#/components/schemas/VoiceMailDetectionResultSuccessModel'
            - $ref: '#/components/schemas/TestToolResultModel'
            - type: 'null'
          title: Result
      type: object
      required:
        - request_id
        - tool_name
        - result_value
        - is_error
        - tool_has_been_called
      title: ConversationHistoryTranscriptSystemToolResultCommonModel
      description: Result from a system tool execution.
    ConversationHistoryTranscriptApiIntegrationWebhookToolsResultCommonModel:
      properties:
        request_id:
          type: string
          title: Request Id
        tool_name:
          type: string
          title: Tool Name
        result_value:
          type: string
          title: Result Value
        is_error:
          type: boolean
          title: Is Error
        tool_has_been_called:
          type: boolean
          title: Tool Has Been Called
        tool_latency_secs:
          type: number
          title: Tool Latency Secs
          default: 0
        dynamic_variable_updates:
          items:
            $ref: '#/components/schemas/DynamicVariableUpdateCommonModel'
          type: array
          title: Dynamic Variable Updates
        type:
          type: string
          const: api_integration_webhook
          title: Type
          default: api_integration_webhook
        integration_id:
          type: string
          title: Integration Id
        credential_id:
          type: string
          title: Credential Id
        integration_connection_id:
          type: string
          title: Integration Connection Id
      type: object
      required:
        - request_id
        - tool_name
        - result_value
        - is_error
        - tool_has_been_called
        - integration_id
        - credential_id
        - integration_connection_id
      title: ConversationHistoryTranscriptApiIntegrationWebhookToolsResultCommonModel
      description: Result from API integration webhook tool execution.
    ConversationHistoryTranscriptWorkflowToolsResultCommonModel:
      properties:
        request_id:
          type: string
          title: Request Id
        tool_name:
          type: string
          title: Tool Name
        result_value:
          type: string
          title: Result Value
        is_error:
          type: boolean
          title: Is Error
        tool_has_been_called:
          type: boolean
          title: Tool Has Been Called
        tool_latency_secs:
          type: number
          title: Tool Latency Secs
          default: 0
        dynamic_variable_updates:
          items:
            $ref: '#/components/schemas/DynamicVariableUpdateCommonModel'
          type: array
          title: Dynamic Variable Updates
        type:
          type: string
          const: workflow
          title: Type
          default: workflow
        result:
          anyOf:
            - $ref: '#/components/schemas/WorkflowToolResponseModel'
            - type: 'null'
      type: object
      required:
        - request_id
        - tool_name
        - result_value
        - is_error
        - tool_has_been_called
      title: ConversationHistoryTranscriptWorkflowToolsResultCommonModel
      description: Result from workflow tool execution.
    UserFeedback:
      properties:
        score:
          $ref: '#/components/schemas/UserFeedbackScore'
        time_in_call_secs:
          type: integer
          title: Time In Call Secs
      type: object
      required:
        - score
        - time_in_call_secs
      title: UserFeedback
      description: User feedback on a transcript turn.
    ConversationTurnMetrics:
      properties:
        metrics:
          additionalProperties:
            $ref: '#/components/schemas/MetricRecord'
          type: object
          title: Metrics
      type: object
      title: ConversationTurnMetrics
      description: Metrics for a conversation turn.
    RagRetrievalInfo:
      properties:
        chunks:
          items:
            $ref: '#/components/schemas/RagChunkMetadata'
          type: array
          title: Chunks
        embedding_model:
          $ref: >-
            #/components/schemas/app__domains__agents__schemas__EmbeddingModelEnum
        retrieval_query:
          type: string
          title: Retrieval Query
        rag_latency_secs:
          type: number
          title: Rag Latency Secs
      type: object
      required:
        - embedding_model
        - retrieval_query
        - rag_latency_secs
      title: RagRetrievalInfo
      description: Information about RAG retrieval for a turn.
    LLMUsage:
      properties:
        model_usage:
          additionalProperties:
            $ref: '#/components/schemas/LLMInputOutputTokensUsage'
          type: object
          title: Model Usage
      type: object
      title: LLMUsage
      description: LLM usage information for a turn.
    AgentMetadata:
      properties:
        agent_id:
          type: string
          title: Agent Id
        branch_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Branch Id
        workflow_node_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Workflow Node Id
      type: object
      required:
        - agent_id
      title: AgentMetadata
      description: >-
        Agent metadata for a transcript turn (used in workflow/handoff
        scenarios).
    ConversationChargingCommonModel:
      properties:
        dev_discount:
          type: boolean
          title: Dev Discount
          description: Whether dev discount was applied
          default: false
        is_burst:
          type: boolean
          title: Is Burst
          description: Whether this was burst usage
          default: false
        tier:
          anyOf:
            - type: string
            - type: 'null'
          title: Tier
          description: Pricing tier
        llm_usage:
          anyOf:
            - $ref: '#/components/schemas/LLMCategoryUsage'
            - type: 'null'
        llm_price:
          anyOf:
            - type: number
            - type: 'null'
          title: Llm Price
          description: Total LLM price
        llm_charge:
          anyOf:
            - type: integer
            - type: 'null'
          title: Llm Charge
          description: LLM charge in credits
        call_charge:
          anyOf:
            - type: integer
            - type: 'null'
          title: Call Charge
          description: Call charge in credits
        free_minutes_consumed:
          type: number
          title: Free Minutes Consumed
          description: Free minutes consumed
          default: 0
        free_llm_dollars_consumed:
          type: number
          title: Free Llm Dollars Consumed
          description: Free LLM dollars consumed
          default: 0
      type: object
      title: ConversationChargingCommonModel
      description: Charging information for a conversation.
    ConversationDeletionSettings:
      properties:
        deletion_time_unix_secs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Deletion Time Unix Secs
        deleted_logs_at_time_unix_secs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Deleted Logs At Time Unix Secs
        deleted_audio_at_time_unix_secs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Deleted Audio At Time Unix Secs
        deleted_transcript_at_time_unix_secs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Deleted Transcript At Time Unix Secs
        delete_transcript_and_pii:
          type: boolean
          title: Delete Transcript And Pii
          default: false
        delete_audio:
          type: boolean
          title: Delete Audio
          default: false
      type: object
      title: ConversationDeletionSettings
      description: Deletion settings for conversation data.
    ConversationHistoryFeedbackCommonModel:
      properties:
        type:
          anyOf:
            - $ref: '#/components/schemas/ConversationFeedbackType'
            - type: 'null'
        overall_score:
          anyOf:
            - $ref: '#/components/schemas/UserFeedbackScore'
            - type: 'null'
        likes:
          type: integer
          title: Likes
          default: 0
        dislikes:
          type: integer
          title: Dislikes
          default: 0
        rating:
          anyOf:
            - type: integer
            - type: 'null'
          title: Rating
        comment:
          anyOf:
            - type: string
            - type: 'null'
          title: Comment
      type: object
      title: ConversationHistoryFeedbackCommonModel
      description: Feedback information for a conversation.
    AuthorizationMethod:
      type: string
      enum:
        - invalid
        - public
        - authorization_header
        - signed_url
        - shareable_link
        - livekit_token
        - livekit_token_website
        - whatsapp
      title: AuthorizationMethod
      description: Authorization method used for conversation
    ConversationHistoryPhoneCallModel:
      properties:
        direction:
          anyOf:
            - $ref: '#/components/schemas/ConversationDirection'
            - type: 'null'
          description: Direction of the call (inbound/outbound/web)
        phone_number_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Phone Number Id
          description: ID of the phone number used
        agent_number:
          anyOf:
            - type: string
            - type: 'null'
          title: Agent Number
          description: The agent's phone number
        external_number:
          anyOf:
            - type: string
            - type: 'null'
          title: External Number
          description: The external caller's phone number
        call_sid:
          anyOf:
            - type: string
            - type: 'null'
          title: Call Sid
          description: Call SID from telephony provider
      type: object
      title: ConversationHistoryPhoneCallModel
      description: Phone call metadata for conversations.
    ConversationHistoryBatchCallModel:
      properties:
        batch_call_id:
          type: string
          title: Batch Call Id
        batch_call_recipient_id:
          type: string
          title: Batch Call Recipient Id
      type: object
      required:
        - batch_call_id
        - batch_call_recipient_id
      title: ConversationHistoryBatchCallModel
      description: Batch call information (for future batch calling feature).
    ConversationHistoryErrorCommonModel:
      properties:
        code:
          type: integer
          title: Code
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
      type: object
      required:
        - code
      title: ConversationHistoryErrorCommonModel
      description: Error information for a conversation.
    ConversationHistoryRagUsageCommonModel:
      properties:
        usage_count:
          type: integer
          title: Usage Count
        embedding_model:
          type: string
          title: Embedding Model
      type: object
      required:
        - usage_count
        - embedding_model
      title: ConversationHistoryRagUsageCommonModel
      description: RAG usage information for a conversation.
    FeaturesUsageCommonModel:
      properties:
        language_detection:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        transfer_to_agent:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        transfer_to_number:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        multivoice:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        dtmf_tones:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        external_mcp_servers:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        pii_zrm_workspace:
          type: boolean
          title: Pii Zrm Workspace
          default: false
        pii_zrm_agent:
          type: boolean
          title: Pii Zrm Agent
          default: false
        tool_dynamic_variable_updates:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        is_livekit:
          type: boolean
          title: Is Livekit
          default: false
        voicemail_detection:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        workflow:
          anyOf:
            - $ref: '#/components/schemas/WorkflowFeaturesUsageCommonModel'
            - type: 'null'
        agent_testing:
          anyOf:
            - $ref: '#/components/schemas/TestsFeatureUsageCommonModel'
            - type: 'null'
        versioning:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
      type: object
      title: FeaturesUsageCommonModel
      description: Features usage tracking for a conversation.
    ConversationHistoryReeAssistantCommonModel:
      properties:
        is_ree_assistant:
          type: boolean
          title: Is Ree Assistant
          default: false
      type: object
      title: ConversationHistoryReeAssistantCommonModel
      description: Ree assistant information for a conversation.
    app__domains__conversations__schemas__ConversationInitiationSource:
      type: string
      enum:
        - unknown
        - widget
        - sip_trunk
        - twilio
        - batch_call
      title: ConversationInitiationSource
      description: Source of conversation initiation
    DefaultConversationInitiationTrigger:
      properties:
        trigger_type:
          type: string
          const: default
          title: Trigger Type
          default: default
      type: object
      title: DefaultConversationInitiationTrigger
      description: Default trigger for standard conversation initiation.
    ZendeskConversationInitiationTrigger:
      properties:
        trigger_type:
          type: string
          const: zendesk
          title: Trigger Type
          default: zendesk
        ticket_id:
          type: integer
          title: Ticket Id
      type: object
      required:
        - ticket_id
      title: ZendeskConversationInitiationTrigger
      description: Trigger for Zendesk-initiated conversations.
    AsyncConversationMetadata:
      properties:
        delivery_status:
          $ref: '#/components/schemas/AsyncDeliveryStatus'
        delivery_timestamp:
          type: integer
          title: Delivery Timestamp
        delivery_error:
          anyOf:
            - type: string
            - type: 'null'
          title: Delivery Error
        external_system:
          type: string
          title: External System
        external_id:
          type: string
          title: External Id
        retry_count:
          type: integer
          title: Retry Count
          default: 0
        last_retry_timestamp:
          anyOf:
            - type: integer
            - type: 'null'
          title: Last Retry Timestamp
      type: object
      required:
        - delivery_status
        - delivery_timestamp
        - external_system
        - external_id
      title: AsyncConversationMetadata
      description: Metadata for async conversation delivery (Zendesk, Slack, etc.).
    WhatsAppConversationInfo:
      properties:
        direction:
          $ref: '#/components/schemas/WhatsAppDirection'
          default: unknown
        whatsapp_phone_number_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Whatsapp Phone Number Id
        whatsapp_user_id:
          type: string
          title: Whatsapp User Id
      type: object
      required:
        - whatsapp_user_id
      title: WhatsAppConversationInfo
      description: WhatsApp conversation information (for future WhatsApp feature).
    AgentDefinitionSource:
      type: string
      enum:
        - cli
        - ui
        - api
        - template
        - unknown
      title: AgentDefinitionSource
      description: Source of agent definition
    EvaluationSuccessResult:
      type: string
      enum:
        - success
        - failure
        - unknown
      title: EvaluationSuccessResult
      description: Result of conversation success evaluation
    ConversationHistoryEvaluationCriteriaResultCommonModel:
      properties:
        criteria_id:
          type: string
          title: Criteria Id
        result:
          $ref: '#/components/schemas/EvaluationSuccessResult'
        rationale:
          type: string
          title: Rationale
      type: object
      required:
        - criteria_id
        - result
        - rationale
      title: ConversationHistoryEvaluationCriteriaResultCommonModel
      description: Result of an evaluation criteria for a conversation.
    DataCollectionResultCommonModel:
      properties:
        data_collection_id:
          type: string
          title: Data Collection Id
        value:
          anyOf:
            - type: string
            - type: integer
            - type: number
            - type: boolean
            - type: 'null'
          title: Value
        json_schema:
          anyOf:
            - $ref: '#/components/schemas/LiteralJsonSchemaProperty'
            - type: 'null'
        rationale:
          type: string
          title: Rationale
      type: object
      required:
        - data_collection_id
        - rationale
      title: DataCollectionResultCommonModel
      description: Result of data collection for a conversation.
    ConversationConfigClientOverride-Output:
      properties:
        turn:
          anyOf:
            - $ref: '#/components/schemas/TurnConfigOverride'
            - type: 'null'
          description: Configuration for turn detection
        tts:
          anyOf:
            - $ref: '#/components/schemas/TTSConversationalConfigOverride'
            - type: 'null'
          description: Configuration for conversational text to speech
        conversation:
          anyOf:
            - $ref: '#/components/schemas/ConversationConfigOverride'
            - type: 'null'
          description: Configuration for conversational events
        agent:
          anyOf:
            - $ref: '#/components/schemas/AgentConfigOverrideInput-Output'
            - type: 'null'
          description: Agent specific configuration
      type: object
      title: ConversationConfigClientOverride-Input
      description: >-
        Subset of conversation settings the client may override at conversation
        start.
    app__domains__conversations__schemas__ConversationInitiationSourceInfo:
      properties:
        source:
          anyOf:
            - $ref: >-
                #/components/schemas/app__domains__conversations__schemas__ConversationInitiationSource
            - type: 'null'
        version:
          anyOf:
            - type: string
              maxLength: 50
            - type: 'null'
          title: Version
          description: The SDK version number
      type: object
      title: ConversationInitiationSourceInfo
      description: Information about the source of conversation initiation.
    ToolType:
      type: string
      enum:
        - system
        - webhook
        - client
        - mcp
        - workflow
        - api_integration_webhook
        - api_integration_mcp
      title: ToolType
      description: Type of tool used in conversation transcripts and tool management
    ConversationHistoryTranscriptToolCallWebhookDetails:
      properties:
        type:
          type: string
          const: webhook
          title: Type
          default: webhook
        url:
          anyOf:
            - type: string
            - type: 'null'
          title: Url
        method:
          anyOf:
            - type: string
            - type: 'null'
          title: Method
        headers:
          additionalProperties:
            type: string
          type: object
          title: Headers
        path_params:
          additionalProperties:
            type: string
          type: object
          title: Path Params
        query_params:
          additionalProperties:
            type: string
          type: object
          title: Query Params
        body:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Body
      type: object
      title: ConversationHistoryTranscriptToolCallWebhookDetails
      description: Details for webhook tool calls.
    ConversationHistoryTranscriptToolCallClientDetails:
      properties:
        type:
          type: string
          const: client
          title: Type
          default: client
      type: object
      title: ConversationHistoryTranscriptToolCallClientDetails
      description: Details for client tool calls.
    ConversationHistoryTranscriptToolCallMCPDetails:
      properties:
        type:
          type: string
          const: mcp
          title: Type
          default: mcp
        server_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Server Url
      type: object
      title: ConversationHistoryTranscriptToolCallMCPDetails
      description: Details for MCP tool calls.
    ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails:
      properties:
        type:
          type: string
          const: api_integration_webhook
          title: Type
          default: api_integration_webhook
        integration_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Integration Id
      type: object
      title: ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails
      description: Details for API integration webhook tool calls.
    DynamicVariableUpdateCommonModel:
      properties:
        variable_name:
          type: string
          title: Variable Name
          description: Name of the variable
        old_value:
          anyOf:
            - type: string
            - type: 'null'
          title: Old Value
          description: Previous value
        new_value:
          type: string
          title: New Value
          description: New value
        updated_at:
          type: number
          title: Updated At
          description: Unix timestamp when updated
        tool_name:
          type: string
          title: Tool Name
          description: Name of the tool that updated the variable
        tool_request_id:
          type: string
          title: Tool Request Id
          description: Request ID of the tool call
      type: object
      required:
        - variable_name
        - old_value
        - new_value
        - updated_at
        - tool_name
        - tool_request_id
      title: DynamicVariableUpdateCommonModel
      description: Tracks a dynamic variable update that occurred during tool execution.
    OtherToolType:
      type: string
      enum:
        - client
        - webhook
        - mcp
      title: OtherToolType
      description: Tool types for non-system tools
    EndCallToolResultModel:
      properties:
        result_type:
          type: string
          const: end_call_success
          title: Result Type
          default: end_call_success
        status:
          type: string
          const: success
          title: Status
          default: success
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
        message:
          anyOf:
            - type: string
            - type: 'null'
          title: Message
      type: object
      title: EndCallToolResultModel
      description: Result from end call tool.
    LanguageDetectionToolResultModel:
      properties:
        result_type:
          type: string
          const: language_detection_success
          title: Result Type
          default: language_detection_success
        status:
          type: string
          const: success
          title: Status
          default: success
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
        language:
          anyOf:
            - type: string
            - type: 'null'
          title: Language
      type: object
      title: LanguageDetectionToolResultModel
      description: Result from language detection tool.
    TransferToAgentToolResultSuccessModel:
      properties:
        result_type:
          type: string
          const: transfer_to_agent_success
          title: Result Type
          default: transfer_to_agent_success
        status:
          type: string
          const: success
          title: Status
          default: success
        from_agent:
          type: string
          title: From Agent
        to_agent:
          type: string
          title: To Agent
        condition:
          type: string
          title: Condition
        delay_ms:
          type: integer
          title: Delay Ms
          default: 0
        transfer_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Transfer Message
        enable_transferred_agent_first_message:
          type: boolean
          title: Enable Transferred Agent First Message
          default: false
      type: object
      required:
        - from_agent
        - to_agent
        - condition
      title: TransferToAgentToolResultSuccessModel
      description: Successful transfer to agent result.
    TransferToAgentToolResultErrorModel:
      properties:
        result_type:
          type: string
          const: transfer_to_agent_error
          title: Result Type
          default: transfer_to_agent_error
        status:
          type: string
          const: error
          title: Status
          default: error
        from_agent:
          type: string
          title: From Agent
        error:
          type: string
          title: Error
      type: object
      required:
        - from_agent
        - error
      title: TransferToAgentToolResultErrorModel
      description: Error during transfer to agent.
    TransferToNumberResultTwilioSuccessModel:
      properties:
        result_type:
          type: string
          const: transfer_to_number_twilio_success
          title: Result Type
          default: transfer_to_number_twilio_success
        status:
          type: string
          const: success
          title: Status
          default: success
        transfer_number:
          type: string
          title: Transfer Number
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
        client_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Client Message
        agent_message:
          type: string
          title: Agent Message
        conference_name:
          type: string
          title: Conference Name
        note:
          anyOf:
            - type: string
            - type: 'null'
          title: Note
      type: object
      required:
        - transfer_number
        - agent_message
        - conference_name
      title: TransferToNumberResultTwilioSuccessModel
      description: Successful Twilio transfer to number result.
    TransferToNumberResultSipSuccessModel:
      properties:
        result_type:
          type: string
          const: transfer_to_number_sip_success
          title: Result Type
          default: transfer_to_number_sip_success
        status:
          type: string
          const: success
          title: Status
          default: success
        transfer_number:
          type: string
          title: Transfer Number
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
        note:
          anyOf:
            - type: string
            - type: 'null'
          title: Note
      type: object
      required:
        - transfer_number
      title: TransferToNumberResultSipSuccessModel
      description: Successful SIP transfer to number result.
    TransferToNumberResultErrorModel:
      properties:
        result_type:
          type: string
          const: transfer_to_number_error
          title: Result Type
          default: transfer_to_number_error
        status:
          type: string
          const: error
          title: Status
          default: error
        error:
          type: string
          title: Error
        details:
          anyOf:
            - type: string
            - type: 'null'
          title: Details
      type: object
      required:
        - error
      title: TransferToNumberResultErrorModel
      description: Error during transfer to number.
    SkipTurnToolResponseModel:
      properties:
        result_type:
          type: string
          const: skip_turn_success
          title: Result Type
          default: skip_turn_success
        status:
          type: string
          const: success
          title: Status
          default: success
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
      type: object
      title: SkipTurnToolResponseModel
      description: Result from skip turn tool.
    PlayDTMFResultSuccessModel:
      properties:
        result_type:
          type: string
          const: play_dtmf_success
          title: Result Type
          default: play_dtmf_success
        status:
          type: string
          const: success
          title: Status
          default: success
        dtmf_tones:
          type: string
          title: Dtmf Tones
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
      type: object
      required:
        - dtmf_tones
      title: PlayDTMFResultSuccessModel
      description: Successful DTMF play result.
    PlayDTMFResultErrorModel:
      properties:
        result_type:
          type: string
          const: play_dtmf_error
          title: Result Type
          default: play_dtmf_error
        status:
          type: string
          const: error
          title: Status
          default: error
        error:
          type: string
          title: Error
        details:
          anyOf:
            - type: string
            - type: 'null'
          title: Details
      type: object
      required:
        - error
      title: PlayDTMFResultErrorModel
      description: Error during DTMF play.
    VoiceMailDetectionResultSuccessModel:
      properties:
        result_type:
          type: string
          const: voicemail_detection_success
          title: Result Type
          default: voicemail_detection_success
        status:
          type: string
          const: success
          title: Status
          default: success
        voicemail_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Voicemail Message
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
      type: object
      title: VoiceMailDetectionResultSuccessModel
      description: Successful voicemail detection result.
    TestToolResultModel:
      properties:
        result_type:
          type: string
          const: testing_tool_result
          title: Result Type
          default: testing_tool_result
        status:
          type: string
          const: success
          title: Status
          default: success
        reason:
          type: string
          title: Reason
          default: Skipping tool call in test mode
      type: object
      title: TestToolResultModel
      description: Result from test mode tool calls.
    WorkflowToolResponseModel:
      properties:
        steps:
          items:
            anyOf:
              - $ref: '#/components/schemas/WorkflowToolEdgeStepModel'
              - $ref: '#/components/schemas/WorkflowToolNestedToolsStepModel'
              - $ref: >-
                  #/components/schemas/WorkflowToolMaxIterationsExceededStepModel
          type: array
          title: Steps
      type: object
      title: WorkflowToolResponseModel
      description: Response from a workflow tool execution.
    UserFeedbackScore:
      type: string
      enum:
        - like
        - dislike
      title: UserFeedbackScore
      description: User feedback score type
    MetricRecord:
      properties:
        elapsed_time:
          type: number
          title: Elapsed Time
      type: object
      required:
        - elapsed_time
      title: MetricRecord
      description: A single metric measurement.
    RagChunkMetadata:
      properties:
        document_id:
          type: string
          title: Document Id
        chunk_id:
          type: string
          title: Chunk Id
        vector_distance:
          type: number
          title: Vector Distance
      type: object
      required:
        - document_id
        - chunk_id
        - vector_distance
      title: RagChunkMetadata
      description: Metadata for a retrieved RAG chunk.
    app__domains__agents__schemas__EmbeddingModelEnum:
      type: string
      enum:
        - gemini-embedding-001
      title: EmbeddingModelEnum
    LLMInputOutputTokensUsage:
      properties:
        input:
          anyOf:
            - $ref: '#/components/schemas/LLMTokensCategoryUsage'
            - type: 'null'
        input_cache_read:
          anyOf:
            - $ref: '#/components/schemas/LLMTokensCategoryUsage'
            - type: 'null'
        input_cache_write:
          anyOf:
            - $ref: '#/components/schemas/LLMTokensCategoryUsage'
            - type: 'null'
        output_total:
          anyOf:
            - $ref: '#/components/schemas/LLMTokensCategoryUsage'
            - type: 'null'
      type: object
      title: LLMInputOutputTokensUsage
      description: Token usage breakdown for input/output.
    LLMCategoryUsage:
      properties:
        irreversible_generation:
          anyOf:
            - $ref: '#/components/schemas/LLMUsage'
            - type: 'null'
        initiated_generation:
          anyOf:
            - $ref: '#/components/schemas/LLMUsage'
            - type: 'null'
      type: object
      title: LLMCategoryUsage
      description: LLM usage by category (irreversible vs initiated generation).
    ConversationFeedbackType:
      type: string
      enum:
        - thumbs
        - rating
      title: ConversationFeedbackType
      description: Type of conversation feedback
    ConversationDirection:
      type: string
      enum:
        - inbound
        - outbound
        - web
      title: ConversationDirection
      description: |-
        Direction of a conversation.

        - inbound: Phone call received (SIP/Twilio)
        - outbound: Phone call initiated by agent
        - web: Web widget / dashboard talk-to initiated conversation
    FeatureStatusCommonModel:
      properties:
        enabled:
          type: boolean
          title: Enabled
          default: false
        used:
          type: boolean
          title: Used
          default: false
      type: object
      title: FeatureStatusCommonModel
      description: Status of a feature (enabled and used).
    WorkflowFeaturesUsageCommonModel:
      properties:
        enabled:
          type: boolean
          title: Enabled
          default: false
        tool_node:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        standalone_agent_node:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        phone_number_node:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
        end_node:
          anyOf:
            - $ref: '#/components/schemas/FeatureStatusCommonModel'
            - type: 'null'
      type: object
      title: WorkflowFeaturesUsageCommonModel
      description: Workflow features usage tracking.
    TestsFeatureUsageCommonModel:
      properties:
        enabled:
          type: boolean
          title: Enabled
          default: false
        tests_ran_after_last_modification:
          type: boolean
          title: Tests Ran After Last Modification
          default: false
        tests_ran_in_last_7_days:
          type: boolean
          title: Tests Ran In Last 7 Days
          default: false
      type: object
      title: TestsFeatureUsageCommonModel
      description: Agent testing features usage tracking.
    AsyncDeliveryStatus:
      type: string
      enum:
        - pending
        - success
        - failed
      title: AsyncDeliveryStatus
      description: Delivery status for async conversations
    WhatsAppDirection:
      type: string
      enum:
        - inbound
        - outbound
        - unknown
      title: WhatsAppDirection
      description: Direction for WhatsApp conversations
    LiteralJsonSchemaProperty:
      properties:
        type:
          type: string
          enum:
            - boolean
            - string
            - integer
            - number
          title: Type
        description:
          type: string
          title: Description
          description: >-
            The description of the property. When set, the LLM will provide the
            value based on this description. Mutually exclusive with
            dynamic_variable, is_system_provided, and constant_value.
          default: ''
        enum:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Enum
          description: List of allowed string values for string type parameters
        is_system_provided:
          type: boolean
          title: Is System Provided
          description: >-
            If true, the value will be populated by the system at runtime. Used
            by API Integration Webhook tools for templating. Mutually exclusive
            with description, dynamic_variable, and constant_value.
          default: false
        dynamic_variable:
          type: string
          title: Dynamic Variable
          description: >-
            The name of the dynamic variable to use for this property's value.
            Mutually exclusive with description, is_system_provided, and
            constant_value.
          default: ''
        constant_value:
          anyOf:
            - type: string
            - type: integer
            - type: number
            - type: boolean
            - type: 'null'
          title: Constant Value
          description: >-
            A constant value to use for this property. Mutually exclusive with
            description, dynamic_variable, and is_system_provided.
      additionalProperties: false
      type: object
      required:
        - type
      title: LiteralJsonSchemaProperty
      example:
        description: A user-provided message
        type: string
    TurnConfigOverride:
      properties:
        soft_timeout_config:
          anyOf:
            - $ref: '#/components/schemas/SoftTimeoutConfigOverride'
            - type: 'null'
          description: >-
            Configuration for soft timeout functionality. Provides immediate
            feedback during longer LLM responses.
      type: object
      title: TurnConfigOverride
    TTSConversationalConfigOverride:
      properties:
        voice_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Voice Id
          description: The voice ID to use for TTS
        stability:
          anyOf:
            - type: number
            - type: 'null'
          title: Stability
          description: The stability of generated speech
        speed:
          anyOf:
            - type: number
            - type: 'null'
          title: Speed
          description: The speed of generated speech
        similarity_boost:
          anyOf:
            - type: number
            - type: 'null'
          title: Similarity Boost
          description: The similarity boost for generated speech
      type: object
      title: TTSConversationalConfigOverride
    ConversationConfigOverride:
      properties:
        text_only:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Text Only
          description: >-
            If enabled audio will not be processed and only text will be used,
            use to avoid audio pricing.
      type: object
      title: ConversationConfigOverride
    AgentConfigOverrideInput-Output:
      properties:
        first_message:
          anyOf:
            - type: string
            - type: 'null'
          title: First Message
          description: >-
            If non-empty, the first message the agent will say. If empty, the
            agent waits for the user to start the discussion.
        language:
          anyOf:
            - type: string
            - type: 'null'
          title: Language
          description: >-
            Primary ISO 639-1 language code for voice (e.g. en, hi, kn). Short
            codes only, not regional BCP-47 (e.g. not hi-IN).
        max_conversation_duration_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Max Conversation Duration Message
          description: >-
            If non-empty, the message the agent will send when max conversation
            duration is reached.
        prompt:
          anyOf:
            - $ref: '#/components/schemas/PromptAgentAPIModelOverride-Output'
            - type: 'null'
          description: The prompt for the agent
      type: object
      title: AgentConfigOverride-Input
    WorkflowToolEdgeStepModel:
      properties:
        step_latency_secs:
          type: number
          title: Step Latency Secs
        type:
          type: string
          const: edge
          title: Type
          default: edge
        edge_id:
          type: string
          title: Edge Id
        target_node_id:
          type: string
          title: Target Node Id
      type: object
      required:
        - step_latency_secs
        - edge_id
        - target_node_id
      title: WorkflowToolEdgeStepModel
      description: A workflow step that traverses an edge.
    WorkflowToolNestedToolsStepModel:
      properties:
        step_latency_secs:
          type: number
          title: Step Latency Secs
        type:
          type: string
          const: nested_tools
          title: Type
          default: nested_tools
        node_id:
          type: string
          title: Node Id
        requests:
          items:
            $ref: >-
              #/components/schemas/ConversationHistoryTranscriptToolCallCommonModel
          type: array
          title: Requests
        results:
          items: {}
          type: array
          title: Results
        is_successful:
          type: boolean
          title: Is Successful
      type: object
      required:
        - step_latency_secs
        - node_id
        - is_successful
      title: WorkflowToolNestedToolsStepModel
      description: A workflow step with nested tool calls.
    WorkflowToolMaxIterationsExceededStepModel:
      properties:
        step_latency_secs:
          type: number
          title: Step Latency Secs
        type:
          type: string
          const: max_iterations_exceeded
          title: Type
          default: max_iterations_exceeded
        max_iterations:
          type: integer
          title: Max Iterations
      type: object
      required:
        - step_latency_secs
        - max_iterations
      title: WorkflowToolMaxIterationsExceededStepModel
      description: Workflow step when max iterations exceeded.
    LLMTokensCategoryUsage:
      properties:
        tokens:
          type: integer
          title: Tokens
          default: 0
        price:
          type: number
          title: Price
          default: 0
      type: object
      title: LLMTokensCategoryUsage
      description: Token usage for a category.
    SoftTimeoutConfigOverride:
      properties:
        message:
          anyOf:
            - type: string
            - type: 'null'
          title: Message
          description: >-
            Message to show when soft timeout is reached while waiting for LLM
            response
      type: object
      title: SoftTimeoutConfigOverride
    PromptAgentAPIModelOverride-Output:
      properties:
        prompt:
          anyOf:
            - type: string
            - type: 'null'
          title: Prompt
          description: The prompt for the agent
        llm:
          anyOf:
            - $ref: '#/components/schemas/LLM'
            - type: 'null'
          description: >-
            The LLM to query with the prompt and the chat history. If using data
            residency, the LLM must be supported in the data residency
            environment
        tool_ids:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Tool Ids
          description: A list of IDs of tools used by the agent
        native_mcp_server_ids:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Native Mcp Server Ids
          description: A list of Native MCP server ids to be used by the agent
        knowledge_base:
          anyOf:
            - items:
                $ref: '#/components/schemas/KnowledgeBaseLocator'
              type: array
            - type: 'null'
          title: Knowledge Base
          description: A list of knowledge bases to be used by the agent
      type: object
      title: PromptAgentAPIModelOverride-Input
    LLM:
      type: string
      enum:
        - gpt-5-mini
        - gemini-2.5-flash
        - gemini-3-flash-preview
        - gpt-4o-mini
      title: LLM
    KnowledgeBaseLocator:
      properties:
        type:
          $ref: '#/components/schemas/KnowledgeBaseDocumentType'
          description: The type of the knowledge base
        name:
          type: string
          title: Name
          description: The name of the knowledge base
        id:
          type: string
          title: Id
          description: The ID of the knowledge base
        usage_mode:
          $ref: '#/components/schemas/DocumentUsageModeEnum'
          description: The usage mode of the knowledge base
          default: auto
      type: object
      required:
        - type
        - name
        - id
      title: KnowledgeBaseLocator
      description: >-
        Reference to a knowledge base document (locator for agent attachment).

        Used when attaching knowledge bases to an agent. Canonical definition
        lives here;

        do not duplicate in other domains.
      example:
        id: '123'
        name: My Knowledge Base
        type: file
        usage_mode: auto
    KnowledgeBaseDocumentType:
      type: string
      enum:
        - file
        - url
        - text
        - folder
      title: KnowledgeBaseDocumentType
      description: Type of knowledge base document
    DocumentUsageModeEnum:
      type: string
      enum:
        - prompt
        - auto
      title: DocumentUsageModeEnum
      description: |-
        How the document is used in agent context.
        - prompt: Always include full document in LLM context
        - auto: Use RAG to retrieve relevant chunks
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      description: API key for programmatic access
      in: header
      name: x-api-key
    HTTPBearer:
      type: http
      description: JWT Bearer token for dashboard access
      scheme: bearer

````